unit CForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Msg, StdCtrls, ExtCtrls, VarProc;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    editField1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    editField2: TEdit;
    Label4: TLabel;
    editIP: TEdit;
    btnSendFields: TButton;
    Panel2: TPanel;
    MsgClient: TMsgClient;
    lblStatus: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    editFileName: TEdit;
    btnSendFile: TButton;
    procedure btnSendFieldsClick(Sender: TObject);
    procedure btnSendFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation      

{$R *.DFM}
var
  counter : Longint;


procedure TForm1.btnSendFieldsClick(Sender: TObject);
begin
  lblStatus.Caption := 'Opening Connection...';
  lblStatus.Refresh;

  MsgClient.RemoteAddress := editIP.Text;
  MsgClient.Open;

  try
    lblStatus.Caption := 'Sending Message...';
    lblStatus.Refresh;

    Inc( counter );
    MsgClient.Connection.Msg.Id := counter;
    MsgClient.Connection.SendMessage( 'FIELDS', 0, [editField1.Text, editField2.Text] );

    lblStatus.Caption := 'Waiting For Reply...';
    lblStatus.Refresh;

    MsgClient.Connection.Receive;
    if ( MsgClient.Connection.Msg.Id = counter ) and ( MsgClient.Connection.Msg.MsgType = 'ACK' ) then begin
      lblStatus.Caption := 'Message Sent Successfully';
    end else begin
      lblStatus.Caption := 'An Error Has Occured';
    end;
    lblStatus.Refresh;

  finally
    MsgClient.Close;
  end;
end;

procedure TForm1.btnSendFileClick(Sender: TObject);
var
  stream   : TStream;
  fileName : String;
  v        : Variant;

begin
  stream := TFileStream.Create( editFileName.Text, fmOpenRead );
  stream.Position := 0;
  StreamToVariant( stream, v );
  stream.Free;
  fileName := editFileName.Text;

  { Extract the file name without the path }
  while ( Pos( '\', fileName ) > 0 ) do begin
    fileName := Copy( fileName, Pos('\', fileName) + 1, 500 );
  end;

  MsgClient.RemoteAddress := editIP.Text;
  MsgClient.Open;

  lblStatus.Caption := 'Sending Message...';
  lblStatus.Refresh;

  Inc( counter );
  MsgClient.Connection.Msg.Id := counter;
  MsgClient.Connection.SendMessage( 'FILE', 0, [fileName, v] );

  lblStatus.Caption := 'Waiting For Reply...';
  lblStatus.Refresh;

  MsgClient.Connection.Receive;
  if ( MsgClient.Connection.Msg.Id = counter ) and ( MsgClient.Connection.Msg.MsgType = 'ACK' ) then begin
    lblStatus.Caption := 'Message Sent Successfully';
  end else begin
    lblStatus.Caption := 'An Error Has Occured';
  end;
  lblStatus.Refresh;

  MsgClient.Close;
end;

end.
