unit SForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Msg, StdCtrls, VarProc;

type
  TServerForm = class(TForm)
    MsgServer: TMsgServer;
    memoConnections: TMemo;
    memoFields: TMemo;
    memoFiles: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure MsgServerConnect(Sender: TObject;
      Connection: TMsgConnection);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MsgServerMessage(Sender: TObject;
      Connection: TMsgConnection);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ServerForm: TServerForm;
  
implementation

{$R *.DFM}

procedure TServerForm.FormShow(Sender: TObject);
begin
  MsgServer.Open;
end;

procedure TServerForm.FormDestroy(Sender: TObject);
begin
  MsgServer.Close;
end;                             

procedure TServerForm.MsgServerConnect(Sender: TObject;
  Connection: TMsgConnection);
begin
  memoConnections.Lines.Add( Connection.Socket.RemoteAddress );
end;

procedure TServerForm.MsgServerMessage(Sender: TObject; Connection: TMsgConnection);
var
  i      : Integer;
  stream : TStream;
  
begin
  if ( Connection.Msg.MsgType = 'FIELDS' ) then begin
    memoFields.Lines.Add( 'Message Id: ' + IntToStr( Connection.Msg.Id ) );
    for i := 0 to ( Connection.Msg.ItemCount - 1 ) do begin
      memoFields.Lines.Add( Connection.Msg.Items[i] );
    end;
    memoFields.Lines.Add( '' );
    { Acknowledge the message }
    Connection.SendMessage( 'ACK', 0 , [NULL] );
  end else if ( Connection.Msg.MsgType = 'FILE' ) then begin
    { Connection.Msg.Items[0] should contain the file name }
    stream := TFileStream.Create( Connection.Msg.Items[0], fmCreate );
    { Connection.Msg.Items[1] should contain the contents of the file }
    VariantToStream( Connection.Msg.Items[1], stream );
    stream.Free;
    memoFiles.Lines.Add( Connection.Msg.Items[0] );
    { Acknowledge the message }
    Connection.SendMessage( 'ACK', 0 , [NULL] );
  end;
end;

end.
